﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using NorthwindModel;
using Telerik.OpenAccess;
using Telerik.Web.UI;

namespace WebTest
{
    public partial class _Default : System.Web.UI.Page
    {
        private NorthwindEntityDiagrams ctx = new NorthwindEntityDiagrams();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                BindMasterTable();

                RadComboBoxCustomers.DataSource = from c in ctx.Customers
                                                  select c.CustomerID;
                RadComboBoxCustomers.DataBind();
            }
        }

        protected void BindMasterTable()
        {
            switch (RadComboBoxSelect.SelectedIndex)
            {
                case 0:     //binding the grid using all of the Customers
                    {
                        RadTextBoxCustomer.Visible = false;
                        RadComboBoxCustomers.Visible = false;

                        RadGridCustomers.DataSource = ctx.Customers;
                        RadGridCustomers.DataBind();
                        break;
                    }
                case 1:     //binding the grid using only one Customer selected by ID
                    {
                        RadTextBoxCustomer.Visible = true;
                        RadComboBoxCustomers.Visible = true;

                        Customer cust = ctx.Customers.Single(x => x.CustomerID.Equals(RadComboBoxCustomers.SelectedItem.Text.Trim()));

                        RadGridCustomers.DataSource = new List<Customer>(){cust};
                        RadGridCustomers.DataBind();
                        break;
                    }
            }
        }

        protected void RadGridCustomers_DetailTableDataBind(object source, GridDetailTableDataBindEventArgs e)
        {

            GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;

            string CustomerID = dataItem.GetDataKeyValue("CustomerID").ToString();

            var orders = from o in ctx.Orders
                         where o.Customer.CustomerID == CustomerID
                         select o;

            e.DetailTableView.DataSource = orders;
        }

        protected void RadComboBoxSelect_SelectedIndexChanged(object o, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            BindMasterTable();
        }

        protected void RadComboBoxCustomers_SelectedIndexChanged(object o, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            BindMasterTable();
        }
        
    }
}
